module Datamappify
  module Data
    module Criteria
      module Relational
        class Find < Common
          def perform
            record = source_class.where(criteria).first

            update_entity_with(record) if record

            record
          end

          private

          def update_entity_with(record)
            attributes.each do |attribute|
              entity.send("#{attribute.name}=", record.send(attribute.source_attribute_name))
            end
          end
        end
      end
    end
  end
end
